<?php
/**
 * ChecklistsApi
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use SLIS\Adapter\Tanss\ApiException;
use SLIS\Adapter\Tanss\Configuration;
use SLIS\Adapter\Tanss\HeaderSelector;
use SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * ChecklistsApi Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ChecklistsApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete
     *
     * Removes a checklist from a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20063
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete($linkTypeId, $linkId, $checklistId)
    {
        list($response) = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteWithHttpInfo($linkTypeId, $linkId, $checklistId);
        return $response;
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteWithHttpInfo
     *
     * Removes a checklist from a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Tanss\Model\InlineResponse20063, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteWithHttpInfo($linkTypeId, $linkId, $checklistId)
    {
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteRequest($linkTypeId, $linkId, $checklistId);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Tanss\Model\InlineResponse20063' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Tanss\Model\InlineResponse20063' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Tanss\Model\InlineResponse20063', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20063';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Tanss\Model\InlineResponse20063',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteAsync
     *
     * Removes a checklist from a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteAsync($linkTypeId, $linkId, $checklistId)
    {
        return $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteAsyncWithHttpInfo($linkTypeId, $linkId, $checklistId)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteAsyncWithHttpInfo
     *
     * Removes a checklist from a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteAsyncWithHttpInfo($linkTypeId, $linkId, $checklistId)
    {
        $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20063';
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteRequest($linkTypeId, $linkId, $checklistId);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete'
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDeleteRequest($linkTypeId, $linkId, $checklistId)
    {
        // verify the required parameter 'linkTypeId' is set
        if ($linkTypeId === null || (is_array($linkTypeId) && count($linkTypeId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkTypeId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete'
            );
        }
        // verify the required parameter 'linkId' is set
        if ($linkId === null || (is_array($linkId) && count($linkId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete'
            );
        }
        // verify the required parameter 'checklistId' is set
        if ($checklistId === null || (is_array($checklistId) && count($checklistId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $checklistId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdDelete'
            );
        }

        $resourcePath = '/api/v1/checklists/assignment/{linkTypeId}/{linkId}/{checklistId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($linkTypeId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkTypeId' . '}',
                ObjectSerializer::toPathValue($linkTypeId),
                $resourcePath
            );
        }
        // path params
        if ($linkId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkId' . '}',
                ObjectSerializer::toPathValue($linkId),
                $resourcePath
            );
        }
        // path params
        if ($checklistId !== null) {
            $resourcePath = str_replace(
                '{' . 'checklistId' . '}',
                ObjectSerializer::toPathValue($checklistId),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost
     *
     * Assigns a checklist to a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20062
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost($linkTypeId, $linkId, $checklistId)
    {
        list($response) = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostWithHttpInfo($linkTypeId, $linkId, $checklistId);
        return $response;
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostWithHttpInfo
     *
     * Assigns a checklist to a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Tanss\Model\InlineResponse20062, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostWithHttpInfo($linkTypeId, $linkId, $checklistId)
    {
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostRequest($linkTypeId, $linkId, $checklistId);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Tanss\Model\InlineResponse20062' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Tanss\Model\InlineResponse20062' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Tanss\Model\InlineResponse20062', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20062';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Tanss\Model\InlineResponse20062',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostAsync
     *
     * Assigns a checklist to a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostAsync($linkTypeId, $linkId, $checklistId)
    {
        return $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostAsyncWithHttpInfo($linkTypeId, $linkId, $checklistId)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostAsyncWithHttpInfo
     *
     * Assigns a checklist to a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostAsyncWithHttpInfo($linkTypeId, $linkId, $checklistId)
    {
        $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20062';
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostRequest($linkTypeId, $linkId, $checklistId);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost'
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     * @param  int $checklistId id of the checklist (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPostRequest($linkTypeId, $linkId, $checklistId)
    {
        // verify the required parameter 'linkTypeId' is set
        if ($linkTypeId === null || (is_array($linkTypeId) && count($linkTypeId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkTypeId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost'
            );
        }
        // verify the required parameter 'linkId' is set
        if ($linkId === null || (is_array($linkId) && count($linkId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost'
            );
        }
        // verify the required parameter 'checklistId' is set
        if ($checklistId === null || (is_array($checklistId) && count($checklistId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $checklistId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdChecklistIdPost'
            );
        }

        $resourcePath = '/api/v1/checklists/assignment/{linkTypeId}/{linkId}/{checklistId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($linkTypeId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkTypeId' . '}',
                ObjectSerializer::toPathValue($linkTypeId),
                $resourcePath
            );
        }
        // path params
        if ($linkId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkId' . '}',
                ObjectSerializer::toPathValue($linkId),
                $resourcePath
            );
        }
        // path params
        if ($checklistId !== null) {
            $resourcePath = str_replace(
                '{' . 'checklistId' . '}',
                ObjectSerializer::toPathValue($checklistId),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdGet
     *
     * Gets checklists for a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20064
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdGet($linkTypeId, $linkId)
    {
        list($response) = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetWithHttpInfo($linkTypeId, $linkId);
        return $response;
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetWithHttpInfo
     *
     * Gets checklists for a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Tanss\Model\InlineResponse20064, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetWithHttpInfo($linkTypeId, $linkId)
    {
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetRequest($linkTypeId, $linkId);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Tanss\Model\InlineResponse20064' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Tanss\Model\InlineResponse20064' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Tanss\Model\InlineResponse20064', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20064';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Tanss\Model\InlineResponse20064',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetAsync
     *
     * Gets checklists for a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetAsync($linkTypeId, $linkId)
    {
        return $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetAsyncWithHttpInfo($linkTypeId, $linkId)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetAsyncWithHttpInfo
     *
     * Gets checklists for a ticket
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetAsyncWithHttpInfo($linkTypeId, $linkId)
    {
        $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20064';
        $request = $this->apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetRequest($linkTypeId, $linkId);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiV1ChecklistsAssignmentLinkTypeIdLinkIdGet'
     *
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiV1ChecklistsAssignmentLinkTypeIdLinkIdGetRequest($linkTypeId, $linkId)
    {
        // verify the required parameter 'linkTypeId' is set
        if ($linkTypeId === null || (is_array($linkTypeId) && count($linkTypeId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkTypeId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdGet'
            );
        }
        // verify the required parameter 'linkId' is set
        if ($linkId === null || (is_array($linkId) && count($linkId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkId when calling apiV1ChecklistsAssignmentLinkTypeIdLinkIdGet'
            );
        }

        $resourcePath = '/api/v1/checklists/assignment/{linkTypeId}/{linkId}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($linkTypeId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkTypeId' . '}',
                ObjectSerializer::toPathValue($linkTypeId),
                $resourcePath
            );
        }
        // path params
        if ($linkId !== null) {
            $resourcePath = str_replace(
                '{' . 'linkId' . '}',
                ObjectSerializer::toPathValue($linkId),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation apiV1ChecklistsCheckPut
     *
     * Check an item
     *
     * @param  \SLIS\Adapter\Tanss\Model\InlineObject26 $inlineObject26 inlineObject26 (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20066
     */
    public function apiV1ChecklistsCheckPut($inlineObject26)
    {
        list($response) = $this->apiV1ChecklistsCheckPutWithHttpInfo($inlineObject26);
        return $response;
    }

    /**
     * Operation apiV1ChecklistsCheckPutWithHttpInfo
     *
     * Check an item
     *
     * @param  \SLIS\Adapter\Tanss\Model\InlineObject26 $inlineObject26 (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Tanss\Model\InlineResponse20066, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiV1ChecklistsCheckPutWithHttpInfo($inlineObject26)
    {
        $request = $this->apiV1ChecklistsCheckPutRequest($inlineObject26);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Tanss\Model\InlineResponse20066' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Tanss\Model\InlineResponse20066' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Tanss\Model\InlineResponse20066', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20066';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Tanss\Model\InlineResponse20066',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiV1ChecklistsCheckPutAsync
     *
     * Check an item
     *
     * @param  \SLIS\Adapter\Tanss\Model\InlineObject26 $inlineObject26 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsCheckPutAsync($inlineObject26)
    {
        return $this->apiV1ChecklistsCheckPutAsyncWithHttpInfo($inlineObject26)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiV1ChecklistsCheckPutAsyncWithHttpInfo
     *
     * Check an item
     *
     * @param  \SLIS\Adapter\Tanss\Model\InlineObject26 $inlineObject26 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsCheckPutAsyncWithHttpInfo($inlineObject26)
    {
        $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20066';
        $request = $this->apiV1ChecklistsCheckPutRequest($inlineObject26);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiV1ChecklistsCheckPut'
     *
     * @param  \SLIS\Adapter\Tanss\Model\InlineObject26 $inlineObject26 (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiV1ChecklistsCheckPutRequest($inlineObject26)
    {
        // verify the required parameter 'inlineObject26' is set
        if ($inlineObject26 === null || (is_array($inlineObject26) && count($inlineObject26) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $inlineObject26 when calling apiV1ChecklistsCheckPut'
            );
        }

        $resourcePath = '/api/v1/checklists/check';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;





        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($inlineObject26)) {
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($inlineObject26));
            } else {
                $httpBody = $inlineObject26;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'PUT',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation apiV1ChecklistsChecklistIdProcessGet
     *
     * Gets checklist for ticket
     *
     * @param  int $checklistId id of the checklist (required)
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20065
     */
    public function apiV1ChecklistsChecklistIdProcessGet($checklistId, $linkTypeId, $linkId)
    {
        list($response) = $this->apiV1ChecklistsChecklistIdProcessGetWithHttpInfo($checklistId, $linkTypeId, $linkId);
        return $response;
    }

    /**
     * Operation apiV1ChecklistsChecklistIdProcessGetWithHttpInfo
     *
     * Gets checklist for ticket
     *
     * @param  int $checklistId id of the checklist (required)
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \SLIS\Adapter\Tanss\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \SLIS\Adapter\Tanss\Model\InlineResponse20065, HTTP status code, HTTP response headers (array of strings)
     */
    public function apiV1ChecklistsChecklistIdProcessGetWithHttpInfo($checklistId, $linkTypeId, $linkId)
    {
        $request = $this->apiV1ChecklistsChecklistIdProcessGetRequest($checklistId, $linkTypeId, $linkId);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\SLIS\Adapter\Tanss\Model\InlineResponse20065' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\SLIS\Adapter\Tanss\Model\InlineResponse20065' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\SLIS\Adapter\Tanss\Model\InlineResponse20065', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20065';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\SLIS\Adapter\Tanss\Model\InlineResponse20065',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation apiV1ChecklistsChecklistIdProcessGetAsync
     *
     * Gets checklist for ticket
     *
     * @param  int $checklistId id of the checklist (required)
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsChecklistIdProcessGetAsync($checklistId, $linkTypeId, $linkId)
    {
        return $this->apiV1ChecklistsChecklistIdProcessGetAsyncWithHttpInfo($checklistId, $linkTypeId, $linkId)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation apiV1ChecklistsChecklistIdProcessGetAsyncWithHttpInfo
     *
     * Gets checklist for ticket
     *
     * @param  int $checklistId id of the checklist (required)
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function apiV1ChecklistsChecklistIdProcessGetAsyncWithHttpInfo($checklistId, $linkTypeId, $linkId)
    {
        $returnType = '\SLIS\Adapter\Tanss\Model\InlineResponse20065';
        $request = $this->apiV1ChecklistsChecklistIdProcessGetRequest($checklistId, $linkTypeId, $linkId);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'apiV1ChecklistsChecklistIdProcessGet'
     *
     * @param  int $checklistId id of the checklist (required)
     * @param  int $linkTypeId linkTypeId (11 &#x3D; ticket) (required)
     * @param  int $linkId id of the ticket (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    public function apiV1ChecklistsChecklistIdProcessGetRequest($checklistId, $linkTypeId, $linkId)
    {
        // verify the required parameter 'checklistId' is set
        if ($checklistId === null || (is_array($checklistId) && count($checklistId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $checklistId when calling apiV1ChecklistsChecklistIdProcessGet'
            );
        }
        // verify the required parameter 'linkTypeId' is set
        if ($linkTypeId === null || (is_array($linkTypeId) && count($linkTypeId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkTypeId when calling apiV1ChecklistsChecklistIdProcessGet'
            );
        }
        // verify the required parameter 'linkId' is set
        if ($linkId === null || (is_array($linkId) && count($linkId) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $linkId when calling apiV1ChecklistsChecklistIdProcessGet'
            );
        }

        $resourcePath = '/api/v1/checklists/{checklistId}/process';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $linkTypeId,
            'linkTypeId', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializer::toQueryValue(
            $linkId,
            'linkId', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);


        // path params
        if ($checklistId !== null) {
            $resourcePath = str_replace(
                '{' . 'checklistId' . '}',
                ObjectSerializer::toPathValue($checklistId),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializer::buildQuery($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializer::buildQuery($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
